﻿@model OperationalRiskException.Core.ViewModels.AssessmentSchedulerVM
@{
    ViewBag.Title = "Assessment Scheduling";
    Layout = "~/Views/Shared/_LayoutProcessor.cshtml";
}

<div class="row">
    <div class="col-md-12 grid-margin">
        <div class="d-flex justify-content-between flex-wrap">
            <div class="d-flex align-items-end flex-wrap">
                <div class="d-flex">
                    <i class="mdi mdi-home text-muted hover-cursor"></i>
                    <p class="text-muted mb-0 hover-cursor">&nbsp;/&nbsp; Configuration Management &nbsp;/&nbsp;</p>
                    <p class="text-primary mb-0 hover-cursor">Assessment Scheduling</p>
                </div>
            </div>

        </div>
    </div>
</div>
<div class="row">
    <div class="col-md-12 grid-margin stretch-card">
        <div class="card">
            <div class="card-body">
                <h4 class="card-title"> Assessment Scheduling Update </h4>
                <p class="card-description">

                </p>

                @using (Html.BeginForm("Update", "AssessmentScheduling", FormMethod.Post, new { @class = "forms-sample", role = "form" }))
                {
                    @Html.AntiForgeryToken()
                    @Html.HiddenFor(x => x.AssessmentSetupId)

                    @Html.HiddenFor(x => x.Id);
                    <div class="row">


                        <div class="form-group col-md-12">
                            <label for="exampleInputUsername1">Select Assessment Period</label>
                            <div class="row col-md-12">
                                @Html.DisplayFor(x => x.AssessmentSchedulerName)
                            </div>
                        </div>

                        <div class="form-group col-md-12">
                            <label for="exampleInputUsername1">
                                Select User(s)
                            </label>
                            <div class="row col-md-12">
                                @Html.DropDownListFor(n => n.ListOfUsers, Enumerable.Empty<SelectListItem>(), "Please select Question", new { @class = "form-control select2 col-md-12", @id = "selectUser", @multiple = "multiple" })
                                @Html.ValidationMessageFor(model => model.ListOfUsers, null, new { @class = "text text-danger" })
                            </div>
                        </div>


                        <button type="submit" class="btn btn-primary mr-2">Update User(s) for Assessment</button>
                    </div>
                }

            </div>
        </div>
    </div>
</div>
<script type="text/javascript">
 

    $(document).ready(function () {
        //DateTimePicker();
       // dataTableLoader();
        toastrFunction();

       var assessmentUrl = '@Url.Action("GetAllPeriod", "AssessmentScheduling")';
        var userURL = '@Url.Action("GetAllUsers", "AssessmentScheduling")';
        ajaxCall('#select2', assessmentUrl);
        ajaxCall('#selectUser', userURL);
     

        var studentSelect = $('#selectUser');
        $.ajax({
            type: 'GET',
            url: '@Url.Action("GetUserbyAssessment","AssessmentScheduling")?Id=' + '@(Model.Id)'
        }).then(function (data) {
    // create the option and append to Select2
      console.log(data)
    data.data.forEach(element => {
        console.log(element.Id)
        var option = new Option(element.Text, element.Id, true, true);
        studentSelect.append(option).trigger('change');
    }
    );
    studentSelect.trigger({
        type: 'select2:select',
        params: {
            data: data
        }
    });
});

   
       
    });


    //GetAllAssessments
    //GetAllUsers
    function ajaxCall(binder, url) {
            
        var pageSize = 20;
       $(binder).select2(
           {

                ajax: {
                    delay: 150,
                    url: url,
                    dataType: 'json',
                    data: function (params) {
                        params.page = params.page || 1;
                        return {
                            searchTerm: params.term,
                            pageSize: pageSize,
                            pageNumber: params.page
                        };
                    },
                    processResults: function (data, params) {
                        params.page = params.page || 1;
                        return {
                            results: data.Results,
                            pagination: {
                                more: (params.page * pageSize) < data.Total
                            }
                        };
                    }
                },
                placeholder: "-- Please select a name --",
                //minimumInputLength: 3,
                allowClear: true,

            });

    }

    
  
   function toastrFunction() {

         if ('@TempData["CreateCat"]'.length > 1) {
          toastr.success('@TempData["CreateCat"]','Notification');
         }
         else  if ('@TempData["Failed"]'.length>1) {
          toastr.error('@TempData["Failed"]','Notification');
       }

    }
</script>
